diff --git a/doc/protocol.md b/doc/protocol.md
index 8df7deebac02..b96514ee4657 100644
--- a/doc/protocol.md
+++ b/doc/protocol.md
@@ -586,7 +586,7 @@ might have the following additional fields:
 
  * "message": A string in the current locale describing the error.
 
-Payload: fsdir1
+Payload: fslist1
 ---------------
 
 A channel of this type lists the files in a directory and will watch
@@ -644,10 +644,10 @@ fields:
  * "tag": The transaction tag for the returned file content.  The tag
    for a non-existing file is "-".
 
-It is not permitted to send data in an fsdir1 channel. This channel
-sends an "done" when all file data was sent.
+It is not permitted to send data in an fslist1 channel. This channel
+sends a "done" when all file data was sent.
 
-Payload: fswrite1
+Payload: fsreplace1
 -----------------
 
 Replace the content of a file.
@@ -662,7 +662,7 @@ The following options can be specified in the "open" control message:
    express that you expect the file to not exist, use "-" as the tag.
 
 You should write the new content to the channel as one or more
-messages.  To indicate the end of the content, send an "done" message.
+messages.  To indicate the end of the content, send a "done" message.
 
 If you don't send any content messages before sending "done", the file
 will be removed.  To create an empty file, send at least one content
diff --git a/pkg/base/cockpit.js b/pkg/base/cockpit.js
index a4051a802b34..b7bd58f13de0 100644
--- a/pkg/base/cockpit.js
+++ b/pkg/base/cockpit.js
@@ -1868,7 +1868,7 @@ function full_scope(cockpit, $, po) {
                 replace_channel.close("abort");
 
             var opts = $.extend({ }, base_channel_options, {
-                payload: "fswrite1",
+                payload: "fsreplace1",
                 path: path,
                 tag: expected_tag
             });
diff --git a/pkg/shell/cockpit-docker.js b/pkg/shell/cockpit-docker.js
index b9a19dde7d34..8a16a60331ac 100644
--- a/pkg/shell/cockpit-docker.js
+++ b/pkg/shell/cockpit-docker.js
@@ -2266,7 +2266,7 @@ function DockerClient() {
 
         http.get("/v1.10/info").done(function(data) {
             var info = data && JSON.parse(data);
-            watch = cockpit.channel({ payload: "fsdir1", path: info["DockerRootDir"]});
+            watch = cockpit.channel({ payload: "fslist1", path: info["DockerRootDir"]});
             $(watch).on("message", function(event, data) {
                 trigger_event();
             });
diff --git a/src/bridge/Makefile.am b/src/bridge/Makefile.am
index 1f76a2e50ca2..52f220d56d00 100644
--- a/src/bridge/Makefile.am
+++ b/src/bridge/Makefile.am
@@ -39,12 +39,12 @@ libcockpit_bridge_a_SOURCES = \
 	src/bridge/cockpitstream.h \
 	src/bridge/cockpitfsread.c \
 	src/bridge/cockpitfsread.h \
-	src/bridge/cockpitfswrite.c \
-	src/bridge/cockpitfswrite.h \
+	src/bridge/cockpitfsreplace.c \
+	src/bridge/cockpitfsreplace.h \
 	src/bridge/cockpitfswatch.c \
 	src/bridge/cockpitfswatch.h \
-	src/bridge/cockpitfsdir.c \
-	src/bridge/cockpitfsdir.h \
+	src/bridge/cockpitfslist.c \
+	src/bridge/cockpitfslist.h \
 	src/bridge/deprecated/cockpitdbusjson1.c \
 	src/bridge/deprecated/cockpitdbusjson1.h \
 	$(NULL)
diff --git a/src/bridge/bridge.c b/src/bridge/bridge.c
index 5449dc6f663d..798cee800956 100644
--- a/src/bridge/bridge.c
+++ b/src/bridge/bridge.c
@@ -22,10 +22,10 @@
 #include "cockpitdbusinternal.h"
 #include "cockpitdbusjson.h"
 #include "cockpitechochannel.h"
-#include "cockpitfsdir.h"
+#include "cockpitfslist.h"
 #include "cockpitfsread.h"
 #include "cockpitfswatch.h"
-#include "cockpitfswrite.h"
+#include "cockpitfsreplace.h"
 #include "cockpithttpstream.h"
 #include "cockpitinteracttransport.h"
 #include "cockpitnullchannel.h"
@@ -124,12 +124,12 @@ process_open (CockpitTransport *transport,
         channel_type = COCKPIT_TYPE_STREAM;
       else if (g_strcmp0 (payload, "fsread1") == 0)
         channel_type = COCKPIT_TYPE_FSREAD;
-      else if (g_strcmp0 (payload, "fswrite1") == 0)
-        channel_type = COCKPIT_TYPE_FSWRITE;
+      else if (g_strcmp0 (payload, "fsreplace1") == 0)
+        channel_type = COCKPIT_TYPE_FSREPLACE;
       else if (g_strcmp0 (payload, "fswatch1") == 0)
         channel_type = COCKPIT_TYPE_FSWATCH;
-      else if (g_strcmp0 (payload, "fsdir1") == 0)
-        channel_type = COCKPIT_TYPE_FSDIR;
+      else if (g_strcmp0 (payload, "fslist1") == 0)
+        channel_type = COCKPIT_TYPE_FSLIST;
       else if (g_strcmp0 (payload, "null") == 0)
         channel_type = COCKPIT_TYPE_NULL_CHANNEL;
       else if (g_strcmp0 (payload, "echo") == 0)
diff --git a/src/bridge/cockpitfsdir.c b/src/bridge/cockpitfslist.c
similarity index 82%
rename from src/bridge/cockpitfsdir.c
rename to src/bridge/cockpitfslist.c
index 7912f991514c..d490573e20a5 100644
--- a/src/bridge/cockpitfsdir.c
+++ b/src/bridge/cockpitfslist.c
@@ -19,7 +19,7 @@
 
 #include "config.h"
 
-#include "cockpitfsdir.h"
+#include "cockpitfslist.h"
 #include "cockpitfswatch.h"
 
 #include "common/cockpitjson.h"
@@ -32,14 +32,14 @@
 #include <string.h>
 
 /**
- * CockpitFsdir:
+ * CockpitFslist:
  *
  * A #CockpitChannel that lists and optionally watches a directory.
  *
- * The payload type for this channel is 'fsdir1'.
+ * The payload type for this channel is 'fslist1'.
  */
 
-#define COCKPIT_FSDIR(o)    (G_TYPE_CHECK_INSTANCE_CAST ((o), COCKPIT_TYPE_FSDIR, CockpitFsdir))
+#define COCKPIT_FSLIST(o)    (G_TYPE_CHECK_INSTANCE_CAST ((o), COCKPIT_TYPE_FSLIST, CockpitFslist))
 
 typedef struct {
   CockpitChannel parent;
@@ -47,24 +47,24 @@ typedef struct {
   GFileMonitor *monitor;
   guint sig_changed;
   GCancellable *cancellable;
-} CockpitFsdir;
+} CockpitFslist;
 
 typedef struct {
   CockpitChannelClass parent_class;
-} CockpitFsdirClass;
+} CockpitFslistClass;
 
-G_DEFINE_TYPE (CockpitFsdir, cockpit_fsdir, COCKPIT_TYPE_CHANNEL);
+G_DEFINE_TYPE (CockpitFslist, cockpit_fslist, COCKPIT_TYPE_CHANNEL);
 
 static void
-cockpit_fsdir_recv (CockpitChannel *channel,
+cockpit_fslist_recv (CockpitChannel *channel,
                     GBytes *message)
 {
-  g_warning ("received unexpected message in fsdir channel");
+  g_warning ("received unexpected message in fslist1 channel");
   cockpit_channel_close (channel, "protocol-error");
 }
 
 static void
-cockpit_fsdir_init (CockpitFsdir *self)
+cockpit_fslist_init (CockpitFslist *self)
 {
 }
 
@@ -95,8 +95,8 @@ on_files_listed (GObject *source_object,
     {
       if (!g_error_matches (error, G_IO_ERROR, G_IO_ERROR_CANCELLED))
         {
-          CockpitFsdir *self = COCKPIT_FSDIR (user_data);
-          g_message ("%s: couldn't process files %s", COCKPIT_FSDIR(user_data)->path, error->message);
+          CockpitFslist *self = COCKPIT_FSLIST (user_data);
+          g_message ("%s: couldn't process files %s", COCKPIT_FSLIST(user_data)->path, error->message);
           options = cockpit_channel_close_options (COCKPIT_CHANNEL (self));
           json_object_set_string_member (options, "message", error->message);
           cockpit_channel_close (COCKPIT_CHANNEL (self), "internal-error");
@@ -105,7 +105,7 @@ on_files_listed (GObject *source_object,
       return;
     }
 
-  CockpitFsdir *self = COCKPIT_FSDIR (user_data);
+  CockpitFslist *self = COCKPIT_FSLIST (user_data);
 
   if (files == NULL)
     {
@@ -172,7 +172,7 @@ on_enumerator_ready (GObject *source_object,
     {
       if (!g_error_matches (error, G_IO_ERROR, G_IO_ERROR_CANCELLED))
         {
-          CockpitFsdir *self = COCKPIT_FSDIR (user_data);
+          CockpitFslist *self = COCKPIT_FSLIST (user_data);
           g_message ("%s: couldn't list directory: %s", self->path, error->message);
           options = cockpit_channel_close_options (COCKPIT_CHANNEL (self));
           json_object_set_string_member (options, "message", error->message);
@@ -182,7 +182,7 @@ on_enumerator_ready (GObject *source_object,
       return;
     }
 
-  CockpitFsdir *self = COCKPIT_FSDIR (user_data);
+  CockpitFslist *self = COCKPIT_FSLIST (user_data);
 
   g_file_enumerator_next_files_async (enumerator,
                                       10,
@@ -199,37 +199,37 @@ on_changed (GFileMonitor      *monitor,
             GFileMonitorEvent  event_type,
             gpointer           user_data)
 {
-  CockpitFsdir *self = COCKPIT_FSDIR(user_data);
+  CockpitFslist *self = COCKPIT_FSLIST(user_data);
   cockpit_fswatch_emit_event (COCKPIT_CHANNEL(self), file, other_file, event_type);
 }
 
 static void
-cockpit_fsdir_prepare (CockpitChannel *channel)
+cockpit_fslist_prepare (CockpitChannel *channel)
 {
-  CockpitFsdir *self = COCKPIT_FSDIR (channel);
+  CockpitFslist *self = COCKPIT_FSLIST (channel);
   const gchar *problem = "protocol-error";
   JsonObject *options;
   GError *error = NULL;
   GFile *file = NULL;
   gboolean watch;
 
-  COCKPIT_CHANNEL_CLASS (cockpit_fsdir_parent_class)->prepare (channel);
+  COCKPIT_CHANNEL_CLASS (cockpit_fslist_parent_class)->prepare (channel);
 
   options = cockpit_channel_get_options (channel);
   if (!cockpit_json_get_string (options, "path", NULL, &self->path))
     {
-      g_warning ("invalid \"path\" option for fsdir channel");
+      g_warning ("invalid \"path\" option for fslist1 channel");
       goto out;
     }
   if (self->path == NULL || *(self->path) == 0)
     {
-      g_warning ("missing \"path\" option for fsdir channel");
+      g_warning ("missing \"path\" option for fslist1 channel");
       goto out;
     }
 
   if (!cockpit_json_get_bool (options, "watch", TRUE, &watch))
     {
-      g_warning ("invalid \"watch\" option for fsdir channel");
+      g_warning ("invalid \"watch\" option for fslist1 channel");
       goto out;
     }
 
@@ -271,9 +271,9 @@ cockpit_fsdir_prepare (CockpitChannel *channel)
 }
 
 static void
-cockpit_fsdir_dispose (GObject *object)
+cockpit_fslist_dispose (GObject *object)
 {
-  CockpitFsdir *self = COCKPIT_FSDIR (object);
+  CockpitFslist *self = COCKPIT_FSLIST (object);
 
   if (self->cancellable)
     g_cancellable_cancel (self->cancellable);
@@ -302,47 +302,47 @@ cockpit_fsdir_dispose (GObject *object)
         }
     }
 
-  G_OBJECT_CLASS (cockpit_fsdir_parent_class)->dispose (object);
+  G_OBJECT_CLASS (cockpit_fslist_parent_class)->dispose (object);
 }
 
 static void
-cockpit_fsdir_finalize (GObject *object)
+cockpit_fslist_finalize (GObject *object)
 {
-  CockpitFsdir *self = COCKPIT_FSDIR (object);
+  CockpitFslist *self = COCKPIT_FSLIST (object);
 
   g_clear_object (&self->cancellable);
   g_clear_object (&self->monitor);
 
-  G_OBJECT_CLASS (cockpit_fsdir_parent_class)->finalize (object);
+  G_OBJECT_CLASS (cockpit_fslist_parent_class)->finalize (object);
 }
 
 static void
-cockpit_fsdir_class_init (CockpitFsdirClass *klass)
+cockpit_fslist_class_init (CockpitFslistClass *klass)
 {
   GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
   CockpitChannelClass *channel_class = COCKPIT_CHANNEL_CLASS (klass);
 
-  gobject_class->dispose = cockpit_fsdir_dispose;
-  gobject_class->finalize = cockpit_fsdir_finalize;
+  gobject_class->dispose = cockpit_fslist_dispose;
+  gobject_class->finalize = cockpit_fslist_finalize;
 
-  channel_class->prepare = cockpit_fsdir_prepare;
-  channel_class->recv = cockpit_fsdir_recv;
+  channel_class->prepare = cockpit_fslist_prepare;
+  channel_class->recv = cockpit_fslist_recv;
 }
 
 /**
- * cockpit_fsdir_open:
+ * cockpit_fslist_open:
  * @transport: the transport to send/receive messages on
  * @channel_id: the channel id
  * @path: the path name of the file to read
  * @watch: boolean, watch the directoy as well?
  *
  * This function is mainly used by tests. The usual way
- * to get a #CockpitFsdir is via cockpit_channel_open()
+ * to get a #CockpitFslist is via cockpit_channel_open()
  *
  * Returns: (transfer full): the new channel
  */
 CockpitChannel *
-cockpit_fsdir_open (CockpitTransport *transport,
+cockpit_fslist_open (CockpitTransport *transport,
                     const gchar *channel_id,
                     const gchar *path,
                     const gboolean watch)
@@ -354,10 +354,10 @@ cockpit_fsdir_open (CockpitTransport *transport,
 
   options = json_object_new ();
   json_object_set_string_member (options, "path", path);
-  json_object_set_string_member (options, "payload", "fsdir1");
+  json_object_set_string_member (options, "payload", "fslist1");
   json_object_set_boolean_member (options, "watch", watch);
 
-  channel = g_object_new (COCKPIT_TYPE_FSDIR,
+  channel = g_object_new (COCKPIT_TYPE_FSLIST,
                           "transport", transport,
                           "id", channel_id,
                           "options", options,
diff --git a/src/bridge/cockpitfsdir.h b/src/bridge/cockpitfslist.h
similarity index 77%
rename from src/bridge/cockpitfsdir.h
rename to src/bridge/cockpitfslist.h
index f15c41a9be10..bfe9ca226546 100644
--- a/src/bridge/cockpitfsdir.h
+++ b/src/bridge/cockpitfslist.h
@@ -17,8 +17,8 @@
  * along with Cockpit; If not, see <http://www.gnu.org/licenses/>.
  */
 
-#ifndef COCKPIT_FSDIR_H__
-#define COCKPIT_FSDIR_H__
+#ifndef COCKPIT_FSLIST_H__
+#define COCKPIT_FSLIST_H__
 
 #include <gio/gio.h>
 
@@ -26,13 +26,13 @@
 
 G_BEGIN_DECLS
 
-#define COCKPIT_TYPE_FSDIR         (cockpit_fsdir_get_type ())
+#define COCKPIT_TYPE_FSLIST         (cockpit_fslist_get_type ())
 
-GType              cockpit_fsdir_get_type     (void) G_GNUC_CONST;
+GType              cockpit_fslist_get_type     (void) G_GNUC_CONST;
 
-CockpitChannel *   cockpit_fsdir_open         (CockpitTransport *transport,
+CockpitChannel *   cockpit_fslist_open         (CockpitTransport *transport,
                                                const gchar *channel_id,
                                                const gchar *path,
                                                const gboolean watch);
 
-#endif /* COCKPIT_FSDIR_H__ */
+#endif /* COCKPIT_FSLIST_H__ */
diff --git a/src/bridge/cockpitfswrite.c b/src/bridge/cockpitfsreplace.c
similarity index 77%
rename from src/bridge/cockpitfswrite.c
rename to src/bridge/cockpitfsreplace.c
index 00f5298b9508..041d0e00a7ff 100644
--- a/src/bridge/cockpitfswrite.c
+++ b/src/bridge/cockpitfsreplace.c
@@ -19,7 +19,7 @@
 
 #include "config.h"
 
-#include "cockpitfswrite.h"
+#include "cockpitfsreplace.h"
 #include "cockpitfsread.h"
 
 #include "common/cockpitjson.h"
@@ -33,14 +33,14 @@
 #include <stdio.h>
 
 /**
- * CockpitFswrite:
+ * CockpitFsreplace:
  *
- * A #CockpitChannel that reads the content of a file.
+ * A #CockpitChannel that writes/replaces the content of a file.
  *
- * The payload type for this channel is 'fswrite1'.
+ * The payload type for this channel is 'fsreplace1'.
  */
 
-#define COCKPIT_FSWRITE(o)    (G_TYPE_CHECK_INSTANCE_CAST ((o), COCKPIT_TYPE_FSWRITE, CockpitFswrite))
+#define COCKPIT_FSREPLACE(o)    (G_TYPE_CHECK_INSTANCE_CAST ((o), COCKPIT_TYPE_FSREPLACE, CockpitFsreplace))
 
 typedef struct {
   CockpitChannel parent;
@@ -50,16 +50,16 @@ typedef struct {
   gboolean got_content;
   const gchar *expected_tag;
   guint sig_close;
-} CockpitFswrite;
+} CockpitFsreplace;
 
 typedef struct {
   CockpitChannelClass parent_class;
-} CockpitFswriteClass;
+} CockpitFsreplaceClass;
 
-G_DEFINE_TYPE (CockpitFswrite, cockpit_fswrite, COCKPIT_TYPE_CHANNEL);
+G_DEFINE_TYPE (CockpitFsreplace, cockpit_fsreplace, COCKPIT_TYPE_CHANNEL);
 
 static const gchar *
-prepare_for_close_with_errno (CockpitFswrite *self,
+prepare_for_close_with_errno (CockpitFsreplace *self,
                               const gchar *diagnostic,
                               int err)
 {
@@ -81,7 +81,7 @@ prepare_for_close_with_errno (CockpitFswrite *self,
 }
 
 static void
-close_with_errno (CockpitFswrite *self,
+close_with_errno (CockpitFsreplace *self,
                   const gchar *diagnostic,
                   int err)
 {
@@ -90,10 +90,10 @@ close_with_errno (CockpitFswrite *self,
 }
 
 static void
-cockpit_fswrite_recv (CockpitChannel *channel,
+cockpit_fsreplace_recv (CockpitChannel *channel,
                       GBytes *message)
 {
-  CockpitFswrite *self = COCKPIT_FSWRITE (channel);
+  CockpitFsreplace *self = COCKPIT_FSREPLACE (channel);
   gsize size;
   const char *data = g_bytes_get_data (message, &size);
 
@@ -143,9 +143,9 @@ xclose (int fd)
 }
 
 static void
-cockpit_fswrite_done (CockpitChannel *channel)
+cockpit_fsreplace_done (CockpitChannel *channel)
 {
-  CockpitFswrite *self = COCKPIT_FSWRITE (channel);
+  CockpitFsreplace *self = COCKPIT_FSREPLACE (channel);
   const gchar *problem = NULL;
   JsonObject *options;
 
@@ -189,10 +189,10 @@ cockpit_fswrite_done (CockpitChannel *channel)
 }
 
 static void
-cockpit_fswrite_close (CockpitChannel *channel,
+cockpit_fsreplace_close (CockpitChannel *channel,
                        const gchar *problem)
 {
-  CockpitFswrite *self = COCKPIT_FSWRITE (channel);
+  CockpitFsreplace *self = COCKPIT_FSREPLACE (channel);
 
   if (self->fd != -1)
     close (self->fd);
@@ -206,40 +206,40 @@ cockpit_fswrite_close (CockpitChannel *channel,
           g_message ("%s: couldn't remove temp file: %s", self->tmp_path, g_strerror (errno));
     }
 
-  COCKPIT_CHANNEL_CLASS (cockpit_fswrite_parent_class)->close (channel, problem);
+  COCKPIT_CHANNEL_CLASS (cockpit_fsreplace_parent_class)->close (channel, problem);
 }
 
 static void
-cockpit_fswrite_init (CockpitFswrite *self)
+cockpit_fsreplace_init (CockpitFsreplace *self)
 {
   self->fd = -1;
 }
 
 static void
-cockpit_fswrite_prepare (CockpitChannel *channel)
+cockpit_fsreplace_prepare (CockpitChannel *channel)
 {
-  CockpitFswrite *self = COCKPIT_FSWRITE (channel);
+  CockpitFsreplace *self = COCKPIT_FSREPLACE (channel);
   const gchar *problem = "protocol-error";
   JsonObject *options;
   gchar *actual_tag = NULL;
 
-  COCKPIT_CHANNEL_CLASS (cockpit_fswrite_parent_class)->prepare (channel);
+  COCKPIT_CHANNEL_CLASS (cockpit_fsreplace_parent_class)->prepare (channel);
 
   options = cockpit_channel_get_options (channel);
   if (!cockpit_json_get_string (options, "path", NULL, &self->path))
     {
-      g_warning ("invalid \"path\" option for fswrite1 channel");
+      g_warning ("invalid \"path\" option for fsreplace1 channel");
       goto out;
     }
   else if (self->path == NULL || g_str_equal (self->path, ""))
     {
-      g_warning ("missing \"path\" option for fswrite1 channel");
+      g_warning ("missing \"path\" option for fsreplace1 channel");
       goto out;
     }
 
   if (!cockpit_json_get_string (options, "tag", NULL, &self->expected_tag))
     {
-      g_warning ("%s: invalid \"tag\" option for fswrite1 channel", self->path);
+      g_warning ("%s: invalid \"tag\" option for fsreplace1 channel", self->path);
       goto out;
     }
 
@@ -277,43 +277,43 @@ cockpit_fswrite_prepare (CockpitChannel *channel)
 }
 
 static void
-cockpit_fswrite_finalize (GObject *object)
+cockpit_fsreplace_finalize (GObject *object)
 {
-  CockpitFswrite *self = COCKPIT_FSWRITE (object);
+  CockpitFsreplace *self = COCKPIT_FSREPLACE (object);
 
   g_free (self->tmp_path);
 
-  G_OBJECT_CLASS (cockpit_fswrite_parent_class)->finalize (object);
+  G_OBJECT_CLASS (cockpit_fsreplace_parent_class)->finalize (object);
 }
 
 static void
-cockpit_fswrite_class_init (CockpitFswriteClass *klass)
+cockpit_fsreplace_class_init (CockpitFsreplaceClass *klass)
 {
   GObjectClass *gobject_class = G_OBJECT_CLASS (klass);
   CockpitChannelClass *channel_class = COCKPIT_CHANNEL_CLASS (klass);
 
-  gobject_class->finalize = cockpit_fswrite_finalize;
+  gobject_class->finalize = cockpit_fsreplace_finalize;
 
-  channel_class->prepare = cockpit_fswrite_prepare;
-  channel_class->recv = cockpit_fswrite_recv;
-  channel_class->done = cockpit_fswrite_done;
-  channel_class->close = cockpit_fswrite_close;
+  channel_class->prepare = cockpit_fsreplace_prepare;
+  channel_class->recv = cockpit_fsreplace_recv;
+  channel_class->done = cockpit_fsreplace_done;
+  channel_class->close = cockpit_fsreplace_close;
 }
 
 /**
- * cockpit_fswrite_open:
+ * cockpit_fsreplace_open:
  * @transport: the transport to send/receive messages on
  * @channel_id: the channel id
  * @path: the path name of the file to write
  * @tag: the expected tag, or NULL
  *
  * This function is mainly used by tests. The usual way
- * to get a #CockpitFswrite is via cockpit_channel_open()
+ * to get a #CockpitFsreplace is via cockpit_channel_open()
  *
  * Returns: (transfer full): the new channel
  */
 CockpitChannel *
-cockpit_fswrite_open (CockpitTransport *transport,
+cockpit_fsreplace_open (CockpitTransport *transport,
                       const gchar *channel_id,
                       const gchar *path,
                       const gchar *tag)
@@ -327,9 +327,9 @@ cockpit_fswrite_open (CockpitTransport *transport,
   json_object_set_string_member (options, "path", path);
   if (tag)
     json_object_set_string_member (options, "tag", tag);
-  json_object_set_string_member (options, "payload", "fswrite1");
+  json_object_set_string_member (options, "payload", "fsreplace1");
 
-  channel = g_object_new (COCKPIT_TYPE_FSWRITE,
+  channel = g_object_new (COCKPIT_TYPE_FSREPLACE,
                           "transport", transport,
                           "id", channel_id,
                           "options", options,
diff --git a/src/bridge/cockpitfswrite.h b/src/bridge/cockpitfsreplace.h
similarity index 76%
rename from src/bridge/cockpitfswrite.h
rename to src/bridge/cockpitfsreplace.h
index 4a10b1b9b6ff..f0161adb55cc 100644
--- a/src/bridge/cockpitfswrite.h
+++ b/src/bridge/cockpitfsreplace.h
@@ -17,8 +17,8 @@
  * along with Cockpit; If not, see <http://www.gnu.org/licenses/>.
  */
 
-#ifndef COCKPIT_FSWRITE_H__
-#define COCKPIT_FSWRITE_H__
+#ifndef COCKPIT_FSREPLACE_H__
+#define COCKPIT_FSREPLACE_H__
 
 #include <gio/gio.h>
 
@@ -26,13 +26,13 @@
 
 G_BEGIN_DECLS
 
-#define COCKPIT_TYPE_FSWRITE         (cockpit_fswrite_get_type ())
+#define COCKPIT_TYPE_FSREPLACE         (cockpit_fsreplace_get_type ())
 
-GType              cockpit_fswrite_get_type     (void) G_GNUC_CONST;
+GType              cockpit_fsreplace_get_type     (void) G_GNUC_CONST;
 
-CockpitChannel *   cockpit_fswrite_open         (CockpitTransport *transport,
+CockpitChannel *   cockpit_fsreplace_open         (CockpitTransport *transport,
                                                  const gchar *channel_id,
                                                  const gchar *path,
                                                  const gchar *tag);
 
-#endif /* COCKPIT_FSWRITE_H__ */
+#endif /* COCKPIT_FSREPLACE_H__ */
diff --git a/src/bridge/test-fs.c b/src/bridge/test-fs.c
index 090e34d8e225..2d19d683af5c 100644
--- a/src/bridge/test-fs.c
+++ b/src/bridge/test-fs.c
@@ -20,9 +20,9 @@
 #include "config.h"
 
 #include "cockpitfsread.h"
-#include "cockpitfswrite.h"
+#include "cockpitfsreplace.h"
 #include "cockpitfswatch.h"
-#include "cockpitfsdir.h"
+#include "cockpitfslist.h"
 #include "mock-transport.h"
 
 #include "common/cockpittest.h"
@@ -95,11 +95,11 @@ setup_fsread_channel (TestCase *tc,
 }
 
 static void
-setup_fswrite_channel (TestCase *tc,
+setup_fsreplace_channel (TestCase *tc,
                        const gchar *path,
                        const gchar *tag)
 {
-  tc->channel = cockpit_fswrite_open (COCKPIT_TRANSPORT (tc->transport), "1234", path, tag);
+  tc->channel = cockpit_fsreplace_open (COCKPIT_TRANSPORT (tc->transport), "1234", path, tag);
   tc->channel_closed = FALSE;
   g_signal_connect (tc->channel, "closed", G_CALLBACK (on_channel_close), tc);
   cockpit_channel_prepare (tc->channel);
@@ -116,11 +116,11 @@ setup_fswatch_channel (TestCase *tc,
 }
 
 static void
-setup_fsdir_channel (TestCase *tc,
+setup_fslist_channel (TestCase *tc,
                      const gchar *path,
                      const gboolean watch)
 {
-  tc->channel = cockpit_fsdir_open (COCKPIT_TRANSPORT (tc->transport), "1234", path, watch);
+  tc->channel = cockpit_fslist_open (COCKPIT_TRANSPORT (tc->transport), "1234", path, watch);
   tc->channel_closed = FALSE;
   g_signal_connect (tc->channel, "closed", G_CALLBACK (on_channel_close), tc);
 }
@@ -414,7 +414,7 @@ test_write_simple (TestCase *tc,
   gchar *tag;
   JsonObject *control;
 
-  setup_fswrite_channel (tc, tc->test_path, NULL);
+  setup_fsreplace_channel (tc, tc->test_path, NULL);
   send_string (tc, "Hello!");
   send_done (tc);
   close_channel (tc, NULL);
@@ -437,7 +437,7 @@ test_write_multiple (TestCase *tc,
   gchar *tag;
   JsonObject *control;
 
-  setup_fswrite_channel (tc, tc->test_path, NULL);
+  setup_fsreplace_channel (tc, tc->test_path, NULL);
   send_string (tc, "Hel");
   send_string (tc, "lo!");
   send_done (tc);
@@ -463,7 +463,7 @@ test_write_remove (TestCase *tc,
 
   set_contents (tc->test_path, "Goodbye!");
   tag = cockpit_get_file_tag (tc->test_path);
-  setup_fswrite_channel (tc, tc->test_path, tag);
+  setup_fsreplace_channel (tc, tc->test_path, tag);
   send_done (tc);
   close_channel (tc, NULL);
   g_free (tag);
@@ -485,7 +485,7 @@ test_write_remove_nonexistent (TestCase *tc,
 
   g_assert (g_file_test (tc->test_path, G_FILE_TEST_EXISTS) == FALSE);
 
-  setup_fswrite_channel (tc, tc->test_path, "-");
+  setup_fsreplace_channel (tc, tc->test_path, "-");
   send_done (tc);
   close_channel (tc, NULL);
 
@@ -507,7 +507,7 @@ test_write_empty (TestCase *tc,
 
   set_contents (tc->test_path, "Goodbye!");
   tag = cockpit_get_file_tag (tc->test_path);
-  setup_fswrite_channel (tc, tc->test_path, tag);
+  setup_fsreplace_channel (tc, tc->test_path, tag);
   send_string (tc, "");
   send_done (tc);
   close_channel (tc, NULL);
@@ -538,7 +538,7 @@ test_write_denied (TestCase *tc,
 
   g_assert (chmod (tc->test_dir, 0) >= 0);
 
-  setup_fswrite_channel (tc, tc->test_path, NULL);
+  setup_fsreplace_channel (tc, tc->test_path, NULL);
   send_string (tc, "Hello!");
   send_done (tc);
   wait_channel_closed (tc);
@@ -556,7 +556,7 @@ test_write_expect_non_existent (TestCase *tc,
   gchar *tag;
   JsonObject *control;
 
-  setup_fswrite_channel (tc, tc->test_path, "-");
+  setup_fsreplace_channel (tc, tc->test_path, "-");
   send_string (tc, "Hello!");
   send_done (tc);
   close_channel (tc, NULL);
@@ -580,7 +580,7 @@ test_write_expect_non_existent_fail (TestCase *tc,
 
   set_contents (tc->test_path, "Goodbye!");
 
-  setup_fswrite_channel (tc, tc->test_path, "-");
+  setup_fsreplace_channel (tc, tc->test_path, "-");
   send_string (tc, "Hello!");
   send_done (tc);
   close_channel (tc, NULL);
@@ -602,7 +602,7 @@ test_write_expect_tag (TestCase *tc,
 
   set_contents (tc->test_path, "Goodbye!");
   tag = cockpit_get_file_tag (tc->test_path);
-  setup_fswrite_channel (tc, tc->test_path, tag);
+  setup_fsreplace_channel (tc, tc->test_path, tag);
   send_string (tc, "Hello!");
   send_done (tc);
   close_channel (tc, NULL);
@@ -628,7 +628,7 @@ test_write_expect_tag_fail (TestCase *tc,
 
   set_contents (tc->test_path, "Goodbye!");
   tag = cockpit_get_file_tag (tc->test_path);
-  setup_fswrite_channel (tc, tc->test_path, tag);
+  setup_fsreplace_channel (tc, tc->test_path, tag);
   send_string (tc, "Hello!");
   set_contents (tc->test_path, "Tschüss!");
   send_done (tc);
@@ -734,7 +734,7 @@ test_dir_simple (TestCase *tc,
 
   set_contents (tc->test_path, "Hello!");
 
-  setup_fsdir_channel (tc, tc->test_dir, TRUE);
+  setup_fslist_channel (tc, tc->test_dir, TRUE);
 
   event = recv_json (tc);
   g_assert_cmpstr (json_object_get_string_member (event, "event"), ==, "present");
@@ -764,7 +764,7 @@ test_dir_simple_no_watch (TestCase *tc,
 
   set_contents (tc->test_path, "Hello!");
 
-  setup_fsdir_channel (tc, tc->test_dir, FALSE);
+  setup_fslist_channel (tc, tc->test_dir, FALSE);
 
   event = recv_json (tc);
   g_assert_cmpstr (json_object_get_string_member (event, "event"), ==, "present");
@@ -793,7 +793,7 @@ test_dir_early_close (TestCase *tc,
 
   set_contents (tc->test_path, "Hello!");
 
-  setup_fsdir_channel (tc, tc->test_dir, TRUE);
+  setup_fslist_channel (tc, tc->test_dir, TRUE);
   close_channel (tc, NULL);
 
   wait_channel_closed (tc);
@@ -808,7 +808,7 @@ test_dir_watch (TestCase *tc,
 {
   JsonObject *event, *control;
 
-  setup_fsdir_channel (tc, tc->test_dir, TRUE);
+  setup_fslist_channel (tc, tc->test_dir, TRUE);
 
   event = recv_json (tc);
   g_assert_cmpstr (json_object_get_string_member (event, "event"), ==, "present-done");
@@ -882,7 +882,7 @@ test_dir_list_fail (TestCase *tc,
                       gconstpointer unused)
 {
   JsonObject *control;
-  setup_fsdir_channel (tc, tc->test_path, FALSE);
+  setup_fslist_channel (tc, tc->test_path, FALSE);
 
   // Channel should close automatically
   wait_channel_closed (tc);
@@ -911,25 +911,25 @@ main (int argc,
   g_test_add ("/fsread/removed", TestCase, NULL,
               setup, test_read_removed, teardown);
 
-  g_test_add ("/fswrite/simple", TestCase, NULL,
+  g_test_add ("/fsreplace/simple", TestCase, NULL,
               setup, test_write_simple, teardown);
-  g_test_add ("/fswrite/multiple", TestCase, NULL,
+  g_test_add ("/fsreplace/multiple", TestCase, NULL,
               setup, test_write_multiple, teardown);
-  g_test_add ("/fswrite/remove", TestCase, NULL,
+  g_test_add ("/fsreplace/remove", TestCase, NULL,
               setup, test_write_remove, teardown);
-  g_test_add ("/fswrite/remove-nonexistent", TestCase, NULL,
+  g_test_add ("/fsreplace/remove-nonexistent", TestCase, NULL,
               setup, test_write_remove_nonexistent, teardown);
-  g_test_add ("/fswrite/empty", TestCase, NULL,
+  g_test_add ("/fsreplace/empty", TestCase, NULL,
               setup, test_write_empty, teardown);
-  g_test_add ("/fswrite/denied", TestCase, NULL,
+  g_test_add ("/fsreplace/denied", TestCase, NULL,
               setup, test_write_denied, teardown);
-  g_test_add ("/fswrite/expect-non-existent", TestCase, NULL,
+  g_test_add ("/fsreplace/expect-non-existent", TestCase, NULL,
               setup, test_write_expect_non_existent, teardown);
-  g_test_add ("/fswrite/expect-non-existent-fail", TestCase, NULL,
+  g_test_add ("/fsreplace/expect-non-existent-fail", TestCase, NULL,
               setup, test_write_expect_non_existent_fail, teardown);
-  g_test_add ("/fswrite/expect-tag", TestCase, NULL,
+  g_test_add ("/fsreplace/expect-tag", TestCase, NULL,
               setup, test_write_expect_tag, teardown);
-  g_test_add ("/fswrite/expect-tag-fail", TestCase, NULL,
+  g_test_add ("/fsreplace/expect-tag-fail", TestCase, NULL,
               setup, test_write_expect_tag_fail, teardown);
 
   g_test_add ("/fswatch/simple", TestCase, NULL,
@@ -939,15 +939,15 @@ main (int argc,
   g_test_add ("/fswatch/directory", TestCase, NULL,
               setup, test_watch_directory, teardown);
 
-  g_test_add ("/fsdir/simple", TestCase, NULL,
+  g_test_add ("/fslist/simple", TestCase, NULL,
               setup, test_dir_simple, teardown);
-  g_test_add ("/fsdir/simple_no_watch", TestCase, NULL,
+  g_test_add ("/fslist/simple_no_watch", TestCase, NULL,
               setup, test_dir_simple_no_watch, teardown);
-  g_test_add ("/fsdir/early-close", TestCase, NULL,
+  g_test_add ("/fslist/early-close", TestCase, NULL,
               setup, test_dir_early_close, teardown);
-  g_test_add ("/fsdir/watch", TestCase, NULL,
+  g_test_add ("/fslist/watch", TestCase, NULL,
               setup, test_dir_watch, teardown);
-  g_test_add ("/fsdir/list_fail", TestCase, NULL,
+  g_test_add ("/fslist/list_fail", TestCase, NULL,
               setup, test_dir_list_fail, teardown);
 
   return g_test_run ();
